git-am.shon commit Merge branch 'mh/reflife' (ede63a1)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005, 2006 Junio C Hamano
   4
   5SUBDIRECTORY_OK=Yes
   6OPTIONS_KEEPDASHDASH=
   7OPTIONS_SPEC="\
   8git am [options] [(<mbox>|<Maildir>)...]
   9git am [options] (--resolved | --skip | --abort)
  10--
  11i,interactive   run interactively
  12b,binary*       (historical option -- no-op)
  133,3way          allow fall back on 3way merging if needed
  14q,quiet         be quiet
  15s,signoff       add a Signed-off-by line to the commit message
  16u,utf8          recode into utf8 (default)
  17k,keep          pass -k flag to git-mailinfo
  18keep-non-patch  pass -b flag to git-mailinfo
  19keep-cr         pass --keep-cr flag to git-mailsplit for mbox format
  20no-keep-cr      do not pass --keep-cr flag to git-mailsplit independent of am.keepcr
  21c,scissors      strip everything before a scissors line
  22whitespace=     pass it through git-apply
  23ignore-space-change pass it through git-apply
  24ignore-whitespace pass it through git-apply
  25directory=      pass it through git-apply
  26exclude=        pass it through git-apply
  27include=        pass it through git-apply
  28C=              pass it through git-apply
  29p=              pass it through git-apply
  30patch-format=   format the patch(es) are in
  31reject          pass it through git-apply
  32resolvemsg=     override error message when patch failure occurs
  33continue        continue applying patches after resolving a conflict
  34r,resolved      synonyms for --continue
  35skip            skip the current patch
  36abort           restore the original branch and abort the patching operation.
  37committer-date-is-author-date    lie about committer date
  38ignore-date     use current timestamp for author date
  39rerere-autoupdate update the index with reused conflict resolution if possible
  40rebasing*       (internal use for git-rebase)"
  41
  42. git-sh-setup
  43. git-sh-i18n
  44prefix=$(git rev-parse --show-prefix)
  45set_reflog_action am
  46require_work_tree
  47cd_to_toplevel
  48
  49git var GIT_COMMITTER_IDENT >/dev/null ||
  50        die "$(gettext "You need to set your committer info first")"
  51
  52if git rev-parse --verify -q HEAD >/dev/null
  53then
  54        HAS_HEAD=yes
  55else
  56        HAS_HEAD=
  57fi
  58
  59cmdline="git am"
  60if test '' != "$interactive"
  61then
  62        cmdline="$cmdline -i"
  63fi
  64if test '' != "$threeway"
  65then
  66        cmdline="$cmdline -3"
  67fi
  68
  69sq () {
  70        git rev-parse --sq-quote "$@"
  71}
  72
  73stop_here () {
  74    echo "$1" >"$dotest/next"
  75    git rev-parse --verify -q HEAD >"$dotest/abort-safety"
  76    exit 1
  77}
  78
  79safe_to_abort () {
  80        if test -f "$dotest/dirtyindex"
  81        then
  82                return 1
  83        fi
  84
  85        if ! test -s "$dotest/abort-safety"
  86        then
  87                return 0
  88        fi
  89
  90        abort_safety=$(cat "$dotest/abort-safety")
  91        if test "z$(git rev-parse --verify -q HEAD)" = "z$abort_safety"
  92        then
  93                return 0
  94        fi
  95        gettextln "You seem to have moved HEAD since the last 'am' failure.
  96Not rewinding to ORIG_HEAD" >&2
  97        return 1
  98}
  99
 100stop_here_user_resolve () {
 101    if [ -n "$resolvemsg" ]; then
 102            printf '%s\n' "$resolvemsg"
 103            stop_here $1
 104    fi
 105    eval_gettextln "When you have resolved this problem, run \"\$cmdline --resolved\".
 106If you prefer to skip this patch, run \"\$cmdline --skip\" instead.
 107To restore the original branch and stop patching, run \"\$cmdline --abort\"."
 108
 109    stop_here $1
 110}
 111
 112go_next () {
 113        rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
 114                "$dotest/patch" "$dotest/info"
 115        echo "$next" >"$dotest/next"
 116        this=$next
 117}
 118
 119cannot_fallback () {
 120        echo "$1"
 121        gettextln "Cannot fall back to three-way merge."
 122        exit 1
 123}
 124
 125fall_back_3way () {
 126    O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
 127
 128    rm -fr "$dotest"/patch-merge-*
 129    mkdir "$dotest/patch-merge-tmp-dir"
 130
 131    # First see if the patch records the index info that we can use.
 132    cmd="git apply $git_apply_opt --build-fake-ancestor" &&
 133    cmd="$cmd "'"$dotest/patch-merge-tmp-index" "$dotest/patch"' &&
 134    eval "$cmd" &&
 135    GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
 136    git write-tree >"$dotest/patch-merge-base+" ||
 137    cannot_fallback "$(gettext "Repository lacks necessary blobs to fall back on 3-way merge.")"
 138
 139    say "$(gettext "Using index info to reconstruct a base tree...")"
 140
 141    cmd='GIT_INDEX_FILE="$dotest/patch-merge-tmp-index"'
 142
 143    if test -z "$GIT_QUIET"
 144    then
 145        eval "$cmd git diff-index --cached --diff-filter=AM --name-status HEAD"
 146    fi
 147
 148    cmd="$cmd git apply --cached $git_apply_opt"' <"$dotest/patch"'
 149    if eval "$cmd"
 150    then
 151        mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
 152        mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
 153    else
 154        cannot_fallback "$(gettext "Did you hand edit your patch?
 155It does not apply to blobs recorded in its index.")"
 156    fi
 157
 158    test -f "$dotest/patch-merge-index" &&
 159    his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
 160    orig_tree=$(cat "$dotest/patch-merge-base") &&
 161    rm -fr "$dotest"/patch-merge-* || exit 1
 162
 163    say "$(gettext "Falling back to patching base and 3-way merge...")"
 164
 165    # This is not so wrong.  Depending on which base we picked,
 166    # orig_tree may be wildly different from ours, but his_tree
 167    # has the same set of wildly different changes in parts the
 168    # patch did not touch, so recursive ends up canceling them,
 169    # saying that we reverted all those changes.
 170
 171    eval GITHEAD_$his_tree='"$FIRSTLINE"'
 172    export GITHEAD_$his_tree
 173    if test -n "$GIT_QUIET"
 174    then
 175            GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
 176    fi
 177    git-merge-recursive $orig_tree -- HEAD $his_tree || {
 178            git rerere $allow_rerere_autoupdate
 179            die "$(gettext "Failed to merge in the changes.")"
 180    }
 181    unset GITHEAD_$his_tree
 182}
 183
 184clean_abort () {
 185        test $# = 0 || echo >&2 "$@"
 186        rm -fr "$dotest"
 187        exit 1
 188}
 189
 190patch_format=
 191
 192check_patch_format () {
 193        # early return if patch_format was set from the command line
 194        if test -n "$patch_format"
 195        then
 196                return 0
 197        fi
 198
 199        # we default to mbox format if input is from stdin and for
 200        # directories
 201        if test $# = 0 || test "x$1" = "x-" || test -d "$1"
 202        then
 203                patch_format=mbox
 204                return 0
 205        fi
 206
 207        # otherwise, check the first few non-blank lines of the first
 208        # patch to try to detect its format
 209        {
 210                # Start from first line containing non-whitespace
 211                l1=
 212                while test -z "$l1"
 213                do
 214                        read l1 || break
 215                done
 216                read l2
 217                read l3
 218                case "$l1" in
 219                "From "* | "From: "*)
 220                        patch_format=mbox
 221                        ;;
 222                '# This series applies on GIT commit'*)
 223                        patch_format=stgit-series
 224                        ;;
 225                "# HG changeset patch")
 226                        patch_format=hg
 227                        ;;
 228                *)
 229                        # if the second line is empty and the third is
 230                        # a From, Author or Date entry, this is very
 231                        # likely an StGIT patch
 232                        case "$l2,$l3" in
 233                        ,"From: "* | ,"Author: "* | ,"Date: "*)
 234                                patch_format=stgit
 235                                ;;
 236                        *)
 237                                ;;
 238                        esac
 239                        ;;
 240                esac
 241                if test -z "$patch_format" &&
 242                        test -n "$l1" &&
 243                        test -n "$l2" &&
 244                        test -n "$l3"
 245                then
 246                        # This begins with three non-empty lines.  Is this a
 247                        # piece of e-mail a-la RFC2822?  Grab all the headers,
 248                        # discarding the indented remainder of folded lines,
 249                        # and see if it looks like that they all begin with the
 250                        # header field names...
 251                        tr -d '\015' <"$1" |
 252                        sed -n -e '/^$/q' -e '/^[       ]/d' -e p |
 253                        sane_egrep -v '^[!-9;-~]+:' >/dev/null ||
 254                        patch_format=mbox
 255                fi
 256        } < "$1" || clean_abort
 257}
 258
 259split_patches () {
 260        case "$patch_format" in
 261        mbox)
 262                if test t = "$keepcr"
 263                then
 264                    keep_cr=--keep-cr
 265                else
 266                    keep_cr=
 267                fi
 268                git mailsplit -d"$prec" -o"$dotest" -b $keep_cr -- "$@" > "$dotest/last" ||
 269                clean_abort
 270                ;;
 271        stgit-series)
 272                if test $# -ne 1
 273                then
 274                        clean_abort "$(gettext "Only one StGIT patch series can be applied at once")"
 275                fi
 276                series_dir=`dirname "$1"`
 277                series_file="$1"
 278                shift
 279                {
 280                        set x
 281                        while read filename
 282                        do
 283                                set "$@" "$series_dir/$filename"
 284                        done
 285                        # remove the safety x
 286                        shift
 287                        # remove the arg coming from the first-line comment
 288                        shift
 289                } < "$series_file" || clean_abort
 290                # set the patch format appropriately
 291                patch_format=stgit
 292                # now handle the actual StGIT patches
 293                split_patches "$@"
 294                ;;
 295        stgit)
 296                this=0
 297                for stgit in "$@"
 298                do
 299                        this=`expr "$this" + 1`
 300                        msgnum=`printf "%0${prec}d" $this`
 301                        # Perl version of StGIT parse_patch. The first nonemptyline
 302                        # not starting with Author, From or Date is the
 303                        # subject, and the body starts with the next nonempty
 304                        # line not starting with Author, From or Date
 305                        perl -ne 'BEGIN { $subject = 0 }
 306                                if ($subject > 1) { print ; }
 307                                elsif (/^\s+$/) { next ; }
 308                                elsif (/^Author:/) { s/Author/From/ ; print ;}
 309                                elsif (/^(From|Date)/) { print ; }
 310                                elsif ($subject) {
 311                                        $subject = 2 ;
 312                                        print "\n" ;
 313                                        print ;
 314                                } else {
 315                                        print "Subject: ", $_ ;
 316                                        $subject = 1;
 317                                }
 318                        ' < "$stgit" > "$dotest/$msgnum" || clean_abort
 319                done
 320                echo "$this" > "$dotest/last"
 321                this=
 322                msgnum=
 323                ;;
 324        hg)
 325                this=0
 326                for hg in "$@"
 327                do
 328                        this=$(( $this + 1 ))
 329                        msgnum=$(printf "%0${prec}d" $this)
 330                        # hg stores changeset metadata in #-commented lines preceding
 331                        # the commit message and diff(s). The only metadata we care about
 332                        # are the User and Date (Node ID and Parent are hashes which are
 333                        # only relevant to the hg repository and thus not useful to us)
 334                        # Since we cannot guarantee that the commit message is in
 335                        # git-friendly format, we put no Subject: line and just consume
 336                        # all of the message as the body
 337                        LANG=C LC_ALL=C perl -M'POSIX qw(strftime)' -ne 'BEGIN { $subject = 0 }
 338                                if ($subject) { print ; }
 339                                elsif (/^\# User /) { s/\# User/From:/ ; print ; }
 340                                elsif (/^\# Date /) {
 341                                        my ($hashsign, $str, $time, $tz) = split ;
 342                                        $tz = sprintf "%+05d", (0-$tz)/36;
 343                                        print "Date: " .
 344                                              strftime("%a, %d %b %Y %H:%M:%S ",
 345                                                       localtime($time))
 346                                              . "$tz\n";
 347                                } elsif (/^\# /) { next ; }
 348                                else {
 349                                        print "\n", $_ ;
 350                                        $subject = 1;
 351                                }
 352                        ' <"$hg" >"$dotest/$msgnum" || clean_abort
 353                done
 354                echo "$this" >"$dotest/last"
 355                this=
 356                msgnum=
 357                ;;
 358        *)
 359                if test -n "$patch_format"
 360                then
 361                        clean_abort "$(eval_gettext "Patch format \$patch_format is not supported.")"
 362                else
 363                        clean_abort "$(gettext "Patch format detection failed.")"
 364                fi
 365                ;;
 366        esac
 367}
 368
 369prec=4
 370dotest="$GIT_DIR/rebase-apply"
 371sign= utf8=t keep= keepcr= skip= interactive= resolved= rebasing= abort=
 372resolvemsg= resume= scissors= no_inbody_headers=
 373git_apply_opt=
 374committer_date_is_author_date=
 375ignore_date=
 376allow_rerere_autoupdate=
 377
 378if test "$(git config --bool --get am.keepcr)" = true
 379then
 380    keepcr=t
 381fi
 382
 383while test $# != 0
 384do
 385        case "$1" in
 386        -i|--interactive)
 387                interactive=t ;;
 388        -b|--binary)
 389                gettextln >&2 "The -b/--binary option has been a no-op for long time, and
 390it will be removed. Please do not use it anymore."
 391                ;;
 392        -3|--3way)
 393                threeway=t ;;
 394        -s|--signoff)
 395                sign=t ;;
 396        -u|--utf8)
 397                utf8=t ;; # this is now default
 398        --no-utf8)
 399                utf8= ;;
 400        -k|--keep)
 401                keep=t ;;
 402        --keep-non-patch)
 403                keep=b ;;
 404        -c|--scissors)
 405                scissors=t ;;
 406        --no-scissors)
 407                scissors=f ;;
 408        -r|--resolved|--continue)
 409                resolved=t ;;
 410        --skip)
 411                skip=t ;;
 412        --abort)
 413                abort=t ;;
 414        --rebasing)
 415                rebasing=t threeway=t ;;
 416        --resolvemsg)
 417                shift; resolvemsg=$1 ;;
 418        --whitespace|--directory|--exclude|--include)
 419                git_apply_opt="$git_apply_opt $(sq "$1=$2")"; shift ;;
 420        -C|-p)
 421                git_apply_opt="$git_apply_opt $(sq "$1$2")"; shift ;;
 422        --patch-format)
 423                shift ; patch_format="$1" ;;
 424        --reject|--ignore-whitespace|--ignore-space-change)
 425                git_apply_opt="$git_apply_opt $1" ;;
 426        --committer-date-is-author-date)
 427                committer_date_is_author_date=t ;;
 428        --ignore-date)
 429                ignore_date=t ;;
 430        --rerere-autoupdate|--no-rerere-autoupdate)
 431                allow_rerere_autoupdate="$1" ;;
 432        -q|--quiet)
 433                GIT_QUIET=t ;;
 434        --keep-cr)
 435                keepcr=t ;;
 436        --no-keep-cr)
 437                keepcr=f ;;
 438        --)
 439                shift; break ;;
 440        *)
 441                usage ;;
 442        esac
 443        shift
 444done
 445
 446# If the dotest directory exists, but we have finished applying all the
 447# patches in them, clear it out.
 448if test -d "$dotest" &&
 449   test -f "$dotest/last" &&
 450   test -f "$dotest/next" &&
 451   last=$(cat "$dotest/last") &&
 452   next=$(cat "$dotest/next") &&
 453   test $# != 0 &&
 454   test "$next" -gt "$last"
 455then
 456   rm -fr "$dotest"
 457fi
 458
 459if test -d "$dotest" && test -f "$dotest/last" && test -f "$dotest/next"
 460then
 461        case "$#,$skip$resolved$abort" in
 462        0,*t*)
 463                # Explicit resume command and we do not have file, so
 464                # we are happy.
 465                : ;;
 466        0,)
 467                # No file input but without resume parameters; catch
 468                # user error to feed us a patch from standard input
 469                # when there is already $dotest.  This is somewhat
 470                # unreliable -- stdin could be /dev/null for example
 471                # and the caller did not intend to feed us a patch but
 472                # wanted to continue unattended.
 473                test -t 0
 474                ;;
 475        *)
 476                false
 477                ;;
 478        esac ||
 479        die "$(eval_gettext "previous rebase directory \$dotest still exists but mbox given.")"
 480        resume=yes
 481
 482        case "$skip,$abort" in
 483        t,t)
 484                die "$(gettext "Please make up your mind. --skip or --abort?")"
 485                ;;
 486        t,)
 487                git rerere clear
 488                git read-tree --reset -u HEAD HEAD
 489                orig_head=$(cat "$GIT_DIR/ORIG_HEAD")
 490                git reset HEAD
 491                git update-ref ORIG_HEAD $orig_head
 492                ;;
 493        ,t)
 494                if test -f "$dotest/rebasing"
 495                then
 496                        exec git rebase --abort
 497                fi
 498                git rerere clear
 499                if safe_to_abort
 500                then
 501                        git read-tree --reset -u HEAD ORIG_HEAD
 502                        git reset ORIG_HEAD
 503                fi
 504                rm -fr "$dotest"
 505                exit ;;
 506        esac
 507        rm -f "$dotest/dirtyindex"
 508else
 509        # Make sure we are not given --skip, --resolved, nor --abort
 510        test "$skip$resolved$abort" = "" ||
 511                die "$(gettext "Resolve operation not in progress, we are not resuming.")"
 512
 513        # Start afresh.
 514        mkdir -p "$dotest" || exit
 515
 516        if test -n "$prefix" && test $# != 0
 517        then
 518                first=t
 519                for arg
 520                do
 521                        test -n "$first" && {
 522                                set x
 523                                first=
 524                        }
 525                        if is_absolute_path "$arg"
 526                        then
 527                                set "$@" "$arg"
 528                        else
 529                                set "$@" "$prefix$arg"
 530                        fi
 531                done
 532                shift
 533        fi
 534
 535        check_patch_format "$@"
 536
 537        split_patches "$@"
 538
 539        # -i can and must be given when resuming; everything
 540        # else is kept
 541        echo " $git_apply_opt" >"$dotest/apply-opt"
 542        echo "$threeway" >"$dotest/threeway"
 543        echo "$sign" >"$dotest/sign"
 544        echo "$utf8" >"$dotest/utf8"
 545        echo "$keep" >"$dotest/keep"
 546        echo "$scissors" >"$dotest/scissors"
 547        echo "$no_inbody_headers" >"$dotest/no_inbody_headers"
 548        echo "$GIT_QUIET" >"$dotest/quiet"
 549        echo 1 >"$dotest/next"
 550        if test -n "$rebasing"
 551        then
 552                : >"$dotest/rebasing"
 553        else
 554                : >"$dotest/applying"
 555                if test -n "$HAS_HEAD"
 556                then
 557                        git update-ref ORIG_HEAD HEAD
 558                else
 559                        git update-ref -d ORIG_HEAD >/dev/null 2>&1
 560                fi
 561        fi
 562fi
 563
 564git update-index -q --refresh
 565
 566case "$resolved" in
 567'')
 568        case "$HAS_HEAD" in
 569        '')
 570                files=$(git ls-files) ;;
 571        ?*)
 572                files=$(git diff-index --cached --name-only HEAD --) ;;
 573        esac || exit
 574        if test "$files"
 575        then
 576                test -n "$HAS_HEAD" && : >"$dotest/dirtyindex"
 577                die "$(eval_gettext "Dirty index: cannot apply patches (dirty: \$files)")"
 578        fi
 579esac
 580
 581# Now, decide what command line options we will give to the git
 582# commands we invoke, based on the result of parsing command line
 583# options and previous invocation state stored in $dotest/ files.
 584
 585if test "$(cat "$dotest/utf8")" = t
 586then
 587        utf8=-u
 588else
 589        utf8=-n
 590fi
 591keep=$(cat "$dotest/keep")
 592case "$keep" in
 593t)
 594        keep=-k ;;
 595b)
 596        keep=-b ;;
 597*)
 598        keep= ;;
 599esac
 600case "$(cat "$dotest/scissors")" in
 601t)
 602        scissors=--scissors ;;
 603f)
 604        scissors=--no-scissors ;;
 605esac
 606if test "$(cat "$dotest/no_inbody_headers")" = t
 607then
 608        no_inbody_headers=--no-inbody-headers
 609else
 610        no_inbody_headers=
 611fi
 612if test "$(cat "$dotest/quiet")" = t
 613then
 614        GIT_QUIET=t
 615fi
 616if test "$(cat "$dotest/threeway")" = t
 617then
 618        threeway=t
 619fi
 620git_apply_opt=$(cat "$dotest/apply-opt")
 621if test "$(cat "$dotest/sign")" = t
 622then
 623        SIGNOFF=`git var GIT_COMMITTER_IDENT | sed -e '
 624                        s/>.*/>/
 625                        s/^/Signed-off-by: /'
 626                `
 627else
 628        SIGNOFF=
 629fi
 630
 631last=`cat "$dotest/last"`
 632this=`cat "$dotest/next"`
 633if test "$skip" = t
 634then
 635        this=`expr "$this" + 1`
 636        resume=
 637fi
 638
 639while test "$this" -le "$last"
 640do
 641        msgnum=`printf "%0${prec}d" $this`
 642        next=`expr "$this" + 1`
 643        test -f "$dotest/$msgnum" || {
 644                resume=
 645                go_next
 646                continue
 647        }
 648
 649        # If we are not resuming, parse and extract the patch information
 650        # into separate files:
 651        #  - info records the authorship and title
 652        #  - msg is the rest of commit log message
 653        #  - patch is the patch body.
 654        #
 655        # When we are resuming, these files are either already prepared
 656        # by the user, or the user can tell us to do so by --resolved flag.
 657        case "$resume" in
 658        '')
 659                if test -f "$dotest/rebasing"
 660                then
 661                        commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
 662                                -e q "$dotest/$msgnum") &&
 663                        test "$(git cat-file -t "$commit")" = commit ||
 664                                stop_here $this
 665                        git cat-file commit "$commit" |
 666                        sed -e '1,/^$/d' >"$dotest/msg-clean"
 667                        echo "$commit" >"$dotest/original-commit"
 668                        get_author_ident_from_commit "$commit" >"$dotest/author-script"
 669                        git diff-tree --root --binary --full-index "$commit" >"$dotest/patch"
 670                else
 671                        git mailinfo $keep $no_inbody_headers $scissors $utf8 "$dotest/msg" "$dotest/patch" \
 672                                <"$dotest/$msgnum" >"$dotest/info" ||
 673                                stop_here $this
 674
 675                        # skip pine's internal folder data
 676                        sane_grep '^Author: Mail System Internal Data$' \
 677                                <"$dotest"/info >/dev/null &&
 678                                go_next && continue
 679
 680                        test -s "$dotest/patch" || {
 681                                eval_gettextln "Patch is empty.  Was it split wrong?
 682If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
 683To restore the original branch and stop patching run \"\$cmdline --abort\"."
 684                                stop_here $this
 685                        }
 686                        rm -f "$dotest/original-commit" "$dotest/author-script"
 687                        {
 688                                sed -n '/^Subject/ s/Subject: //p' "$dotest/info"
 689                                echo
 690                                cat "$dotest/msg"
 691                        } |
 692                        git stripspace > "$dotest/msg-clean"
 693                fi
 694                ;;
 695        esac
 696
 697        if test -f "$dotest/author-script"
 698        then
 699                eval $(cat "$dotest/author-script")
 700        else
 701                GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
 702                GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
 703                GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
 704        fi
 705
 706        if test -z "$GIT_AUTHOR_EMAIL"
 707        then
 708                gettextln "Patch does not have a valid e-mail address."
 709                stop_here $this
 710        fi
 711
 712        export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
 713
 714        case "$resume" in
 715        '')
 716            if test '' != "$SIGNOFF"
 717            then
 718                LAST_SIGNED_OFF_BY=`
 719                    sed -ne '/^Signed-off-by: /p' \
 720                    "$dotest/msg-clean" |
 721                    sed -ne '$p'
 722                `
 723                ADD_SIGNOFF=`
 724                    test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
 725                    test '' = "$LAST_SIGNED_OFF_BY" && echo
 726                    echo "$SIGNOFF"
 727                }`
 728            else
 729                ADD_SIGNOFF=
 730            fi
 731            {
 732                if test -s "$dotest/msg-clean"
 733                then
 734                        cat "$dotest/msg-clean"
 735                fi
 736                if test '' != "$ADD_SIGNOFF"
 737                then
 738                        echo "$ADD_SIGNOFF"
 739                fi
 740            } >"$dotest/final-commit"
 741            ;;
 742        *)
 743                case "$resolved$interactive" in
 744                tt)
 745                        # This is used only for interactive view option.
 746                        git diff-index -p --cached HEAD -- >"$dotest/patch"
 747                        ;;
 748                esac
 749        esac
 750
 751        resume=
 752        if test "$interactive" = t
 753        then
 754            test -t 0 ||
 755            die "$(gettext "cannot be interactive without stdin connected to a terminal.")"
 756            action=again
 757            while test "$action" = again
 758            do
 759                gettextln "Commit Body is:"
 760                echo "--------------------------"
 761                cat "$dotest/final-commit"
 762                echo "--------------------------"
 763                # TRANSLATORS: Make sure to include [y], [n], [e], [v] and [a]
 764                # in your translation. The program will only accept English
 765                # input at this point.
 766                gettext "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
 767                read reply
 768                case "$reply" in
 769                [yY]*) action=yes ;;
 770                [aA]*) action=yes interactive= ;;
 771                [nN]*) action=skip ;;
 772                [eE]*) git_editor "$dotest/final-commit"
 773                       action=again ;;
 774                [vV]*) action=again
 775                       git_pager "$dotest/patch" ;;
 776                *)     action=again ;;
 777                esac
 778            done
 779        else
 780            action=yes
 781        fi
 782
 783        if test $action = skip
 784        then
 785                go_next
 786                continue
 787        fi
 788
 789        if test -x "$GIT_DIR"/hooks/applypatch-msg
 790        then
 791                "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
 792                stop_here $this
 793        fi
 794
 795        if test -f "$dotest/final-commit"
 796        then
 797                FIRSTLINE=$(sed 1q "$dotest/final-commit")
 798        else
 799                FIRSTLINE=""
 800        fi
 801
 802        say "$(eval_gettext "Applying: \$FIRSTLINE")"
 803
 804        case "$resolved" in
 805        '')
 806                # When we are allowed to fall back to 3-way later, don't give
 807                # false errors during the initial attempt.
 808                squelch=
 809                if test "$threeway" = t
 810                then
 811                        squelch='>/dev/null 2>&1 '
 812                fi
 813                eval "git apply $squelch$git_apply_opt"' --index "$dotest/patch"'
 814                apply_status=$?
 815                ;;
 816        t)
 817                # Resolved means the user did all the hard work, and
 818                # we do not have to do any patch application.  Just
 819                # trust what the user has in the index file and the
 820                # working tree.
 821                resolved=
 822                git diff-index --quiet --cached HEAD -- && {
 823                        gettextln "No changes - did you forget to use 'git add'?
 824If there is nothing left to stage, chances are that something else
 825already introduced the same changes; you might want to skip this patch."
 826                        stop_here_user_resolve $this
 827                }
 828                unmerged=$(git ls-files -u)
 829                if test -n "$unmerged"
 830                then
 831                        gettextln "You still have unmerged paths in your index
 832did you forget to use 'git add'?"
 833                        stop_here_user_resolve $this
 834                fi
 835                apply_status=0
 836                git rerere
 837                ;;
 838        esac
 839
 840        if test $apply_status != 0 && test "$threeway" = t
 841        then
 842                if (fall_back_3way)
 843                then
 844                    # Applying the patch to an earlier tree and merging the
 845                    # result may have produced the same tree as ours.
 846                    git diff-index --quiet --cached HEAD -- && {
 847                        say "$(gettext "No changes -- Patch already applied.")"
 848                        go_next
 849                        continue
 850                    }
 851                    # clear apply_status -- we have successfully merged.
 852                    apply_status=0
 853                fi
 854        fi
 855        if test $apply_status != 0
 856        then
 857                eval_gettextln 'Patch failed at $msgnum $FIRSTLINE'
 858                if test "$(git config --bool advice.amworkdir)" != false
 859                then
 860                        eval_gettextln 'The copy of the patch that failed is found in:
 861   $dotest/patch'
 862                fi
 863                stop_here_user_resolve $this
 864        fi
 865
 866        if test -x "$GIT_DIR"/hooks/pre-applypatch
 867        then
 868                "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
 869        fi
 870
 871        tree=$(git write-tree) &&
 872        commit=$(
 873                if test -n "$ignore_date"
 874                then
 875                        GIT_AUTHOR_DATE=
 876                fi
 877                parent=$(git rev-parse --verify -q HEAD) ||
 878                say >&2 "$(gettext "applying to an empty history")"
 879
 880                if test -n "$committer_date_is_author_date"
 881                then
 882                        GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
 883                        export GIT_COMMITTER_DATE
 884                fi &&
 885                git commit-tree $tree ${parent:+-p} $parent <"$dotest/final-commit"
 886        ) &&
 887        git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
 888        stop_here $this
 889
 890        if test -f "$dotest/original-commit"; then
 891                echo "$(cat "$dotest/original-commit") $commit" >> "$dotest/rewritten"
 892        fi
 893
 894        if test -x "$GIT_DIR"/hooks/post-applypatch
 895        then
 896                "$GIT_DIR"/hooks/post-applypatch
 897        fi
 898
 899        go_next
 900done
 901
 902if test -s "$dotest"/rewritten; then
 903    git notes copy --for-rewrite=rebase < "$dotest"/rewritten
 904    if test -x "$GIT_DIR"/hooks/post-rewrite; then
 905        "$GIT_DIR"/hooks/post-rewrite rebase < "$dotest"/rewritten
 906    fi
 907fi
 908
 909# If am was called with --rebasing (from git-rebase--am), it's up to
 910# the caller to take care of housekeeping.
 911if ! test -f "$dotest/rebasing"
 912then
 913        rm -fr "$dotest"
 914        git gc --auto
 915fi